#include <windows.h>
#include <gl\gl.h>
#include "i_system.h"

extern HDC hDC;
HGLRC hRC = NULL;
int	glvers;

void I_InitGraphics(void)
{
	int nPixelFormat;
	PIXELFORMATDESCRIPTOR pfd = {
	sizeof(PIXELFORMATDESCRIPTOR),  // Size of this structure
	1,                              // Version of this structure    
	PFD_DRAW_TO_WINDOW |            // Draw to Window (not to bitmap)
	PFD_SUPPORT_OPENGL |		    // Support OpenGL calls in window
	PFD_DOUBLEBUFFER,               // Double buffered
	PFD_TYPE_RGBA,                  // RGBA Color mode
	24,                             // Want 24bit color 
	0,0,0,0,0,0,                    // Not used to select mode
	0,0,                            // Not used to select mode
	0,0,0,0,0,                      // Not used to select mode
	32,                             // Size of depth buffer
	0/*1*/,                         // @cStencilBits
	0,                              // Not used to select mode
	0, // PFD_MAIN_PLANE,           // Draw in main plane
	0,                              // Not used to select mode
	0,0,0 };
    char*   glstring;
	
	nPixelFormat = ChoosePixelFormat(hDC, &pfd);
	SetPixelFormat(hDC, nPixelFormat, &pfd);
	hRC = wglCreateContext(hDC);
	wglMakeCurrent(hDC, hRC);
	//glViewport(0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));

    glstring = (char *)glGetString(GL_VERSION);
    I_Debug("GL_VERSION:\t%s\n", glstring);
    glvers = atoi(glstring); // @擪10ilӖ镔܂łϊ(uANSI C/C++ TvQ)
    glstring = (char *)glGetString(GL_VENDOR);
    I_Debug("GL_VENDOR:\t%s\n", glstring);
    glstring = (char *)glGetString(GL_RENDERER);
    I_Debug("GL_RENDERER:\t%s\n", glstring);

	glEnable(GL_CULL_FACE);
    glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_ALPHA_TEST);
    glAlphaFunc(GL_NOTEQUAL, 0);
    //glEnable(GL_STENCIL_TEST);
    //glClearStencil(0); @ftHg
}

void I_ShutdownGraphics(void)
{
    if (hRC)
    {
	    wglMakeCurrent(hDC, NULL);
	    wglDeleteContext(hRC);
	    hRC = NULL;
    }
}

void I_FinishUpdate (void)
{
	SwapBuffers(hDC);
}

//
// I_SetPalette
//
void I_SetPalette (byte* palette)
{
    //UploadNewPalette(X_cmap, palette);
}
