#include <windows.h>
#include <gl\gl.h> // @windows.hsĂȂ΂ȂȂ
#include <gl\glu.h>
#include <stdlib.h>
#include <stdio.h>
#include "v_video.h"
#include "w_wad.h"
#include "z_zone.h"
#include "i_system.h"
#include "hu_stuff.h"
#include "m_swap.h"
#include "r_data.h"
#include "doomstat.h"
#include "m_argv.h"

int	        usegamma;
byte*		playpal;

GLuint*     texture_objects;
int         minfilter;
int         magfilter;
int         patchfilter;
int         spritefilter;
int         texborder;
GLenum      minfiltertype;
GLenum      magfiltertype;

//
// Misc. patch names
//
char* mpnames[] = 
{
	"TITLEPIC",
    "HELP",
	"HELP1",
	"CREDIT",
	"HELP2",
    "M_PAUSE",

	// Menu	
	"M_LOADG",
	"M_LSLEFT",
	"M_LSCNTR",
	"M_LSRGHT",
	"M_SAVEG",
	"M_SVOL",
	"M_DOOM",
	"M_NEWG",
	"M_SKILL",
	"M_EPISOD",
	"M_OPTTTL",
	"M_GDHIGH",
	"M_GDLOW",
	"M_MSGOFF",
	"M_MSGON",
	"M_THERML",
	"M_THERMM",
	"M_THERMR",
	"M_THERMO",
	"M_CELL1", // not
	"M_CELL2", //  used?
	"M_SKULL1",
	"M_SKULL2",
	"M_NGAME",
	"M_OPTION",
	"M_RDTHIS",
	"M_QUITG",
	"M_EPI1",
	"M_EPI2",
	"M_EPI3",
	"M_EPI4",
	"M_JKILL",
	"M_ROUGH",
	"M_HURT",
	"M_ULTRA",
	"M_NMARE",
	"M_ENDGAM",
	"M_MESSG",
	"M_DETAIL",
	"M_SCRNSZ",
	"M_MSENS",
	"M_SFXVOL",
	"M_MUSVOL",

    // Status bar
    "STBAR",    // entire status bar background
    "STFST00",  // faces
    "STFST01",
    "STFST02",
    "STFST10",
    "STFST11",
    "STFST12",
    "STFST20",
    "STFST21",
    "STFST22",
    "STFST30",
    "STFST31",
    "STFST32",
    "STFST40",
    "STFST41",
    "STFST42",
    "STFTR00",
    "STFTR10",
    "STFTR20",
    "STFTR30",
    "STFTR40",
    "STFTL00",
    "STFTL10",
    "STFTL20",
    "STFTL30",
    "STFTL40",
    "STFOUCH0",
    "STFOUCH1",
    "STFOUCH2",
    "STFOUCH3",
    "STFOUCH4",
    "STFEVL0",
    "STFEVL1",
    "STFEVL2",
    "STFEVL3",
    "STFEVL4",
    "STFKILL0",
    "STFKILL1",
    "STFKILL2",
    "STFKILL3",
    "STFKILL4",
    "STFGOD0",
    "STFDEAD0",
    "STTNUM0",  // tall number
    "STTNUM1",
    "STTNUM2",
    "STTNUM3",
    "STTNUM4",
    "STTNUM5",
    "STTNUM6",
    "STTNUM7",
    "STTNUM8",
    "STTNUM9",
    "STYSNUM0", // short number. 2 to 7 are also weapon number(yellow)
    "STYSNUM1",
    "STYSNUM2",
    "STYSNUM3",
    "STYSNUM4",
    "STYSNUM5",
    "STYSNUM6",
    "STYSNUM7",
    "STYSNUM8",
    "STYSNUM9",
    "STGNUM2",  // weapon number(gray)
    "STGNUM3",
    "STGNUM4",
    "STGNUM5",
    "STGNUM6",
    "STGNUM7",
    "STKEYS0",  // key cards
    "STKEYS1",
    "STKEYS2",
    "STKEYS3",
    "STKEYS4",
    "STKEYS5",
    "STTPRCNT", // tall percent
    "STTMINUS", // minus sign
    "STARMS",   // arms background
    "STFB0",    // face backgrounds
    "STFB1",
    "STFB2",
    "STFB3",

    // Intermission 
    "INTERPIC",
    "WIMAP0",
    "WIMAP1",
    "WIMAP2",
    "WIURH0",   // you are here
    "WIURH1",   // you are here (alt.)
    "WISPLAT",  // splat
    "WIMINUS",
    "WIPCNT",
    "WIF",
    "WIENTER",
    "WIOSTK",
    "WIOSTS",
    "WISCRT2",
    "WIOBJ",
    "WIOSTI",
    "WIFRGS",
    "WICOLON",
    "WITIME",
    "WISUCKS",
    "WIPAR",
    "WIKILRS",
    "WIVCTMS",
    "WIMSTT",
    "STFST01",
    "STFDEAD0",
    "STPB0",
    "STPB1",
    "STPB2",
    "STPB3",
    "WIBP1",
    "WIBP2",
    "WIBP3",
    "WIBP4",

    // Finale
    "VICTORY2",
    "ENDPIC",
    "PFUB1",
    "PFUB2",
    "END0",
    "END1",
    "END2",
    "END3",
    "END4",
    "END5",
    "END6",
    "BOSSBACK"
};

void
V_DrawPatch
( int		x,
  int		y,
  int		scrn,
  patch_t*	patch ) 
{
	int     i;
    int     s1, s2;

	for (i=0 ; i<numlumps ; i++)
		if (lumpcache[i] == patch)
			break;

	if ((int)texture_objects[i] == -1 || i == numlumps)
        return;

    if (scrn == -1)
    {
        s1 = 1;
        s2 = 0;
    } else
    {
        s1 = 0;
        s2 = 1;
    }

	y -= SHORT(patch->topoffset); 
    x -= SHORT(patch->leftoffset);

	glBindTexture(GL_TEXTURE_2D, texture_objects[i]);
	glBegin(GL_QUADS);
		glTexCoord2i(s1, 0);
		glVertex2i(x, y);
		glTexCoord2i(s1, 1);
		glVertex2i(x, y+SHORT(patch->height));
		glTexCoord2i(s2, 1);
		glVertex2i(x+SHORT(patch->width), y+SHORT(patch->height));
		glTexCoord2i(s2, 0);
		glVertex2i(x+SHORT(patch->width), y);
	glEnd();
}

void
V_DrawPatchFlipped
( int		x,
  int		y,
  int		scrn,
  patch_t*	patch ) 
{
    V_DrawPatch(x, y, -1, patch);
}

void
V_DrawPatchDirect
( int		x,
  int		y,
  int		scrn,
  patch_t*	patch ) 
{
    V_DrawPatch (x,y,scrn, patch);
}

void ResampleTexture (unsigned *in, int inwidth, int inheight, unsigned *out,  int outwidth, int outheight)
{
	int		i, j, k, l;
	unsigned	*inrow;

    // V1.6 
    // @}XNt摜ɂ͂܂Ȃ
    gluScaleImage(GL_RGBA, inwidth, inheight, GL_UNSIGNED_BYTE, in, outwidth, outheight, GL_UNSIGNED_BYTE, out);
    return;

	for (i=0 ; i<outheight ; i++, out+=outwidth)
	{
		if (inheight == outheight)
			l = i;
		else
			l = (int)(i/(float)outheight*inheight); // @outheightinheightꍇ̒liɂȂ邪A_ł̒li኱Ȃꍇ͐؂艺鋰ꂪ

		inrow = in + inwidth*l;

		for (j=0 ; j<outwidth ; j++)
		{
			if (inwidth == outwidth)
				k = j;
			else
				k = (int)(j/(float)outwidth*inwidth);

			out[j] = inrow[k];
		}
	}
}

void DrawColumnInRGBA(post_t* post, byte* data, int x, int originy, int pitch, int height)
{
	int     count;
    int     toprow;
    byte*	source;
    int     i;
	byte*	dest;
	int		index;

    while (post->topdelta != 0xff)
    {
        count = post->length;
        toprow = originy + post->topdelta;
        source = (byte *)post + 3;

        if (toprow < 0) // @originy̎ɉ\
        {
            count += toprow;
            source -= toprow; 
            toprow = 0;
        }

        if (toprow + count > height)
            count = height - toprow;

        if (count > 0)
            for (i=0 ; i<count ; i++)
            {
                dest = data + 4*((toprow+i)*pitch + x);
				index = source[i];
                dest[0] = playpal[index*3];
				dest[1] = playpal[index*3+1];
				dest[2] = playpal[index*3+2];
				dest[3] = 255;
            }

        post = (post_t *)((byte *)post + post->length + 4); // @post
    }
}

//GLfloat bordercolor[4] = { 0, 0, 0, 0 };
extern int  glvers;

unsigned* AddBorderToImage(unsigned* data, int width, int height, int border);
unsigned* FillBlankPixelsWithAdjacentColors(unsigned* data, int width, int height);

GLuint CreateTexureObjectFromPatch(patch_t* patch, GLenum mintype, GLenum magtype)
{
	GLuint		texture;
	int			width, height, scaled_width, scaled_height;
	unsigned	*data, *scaled_data;
	int			size, i;
	post_t*		column;
    int         border = 0;

	width = SHORT(patch->width);
	height = SHORT(patch->height);

	size = width * height * 4;
	data = calloc(size, 1);

	for (i=0 ; i<width ; i++)
	{
		column = (post_t *)((byte *)patch + patch->columnofs[i]);
        DrawColumnInRGBA(column, (byte *)data, i, 0, width, height);
    }

    if (glvers >= 2)
    {
        scaled_width = width;
        scaled_height = height;
        goto next;
    }

	for (scaled_width = 1 ; scaled_width < width ; scaled_width <<= 1)
		;
	for (scaled_height = 1 ; scaled_height < height ; scaled_height <<= 1)
		;

	if (width != scaled_width || height != scaled_height)
	{
		size = scaled_width * scaled_height * 4;
		scaled_data = calloc(size, 1);
		ResampleTexture(data, width, height, scaled_data, scaled_width, scaled_height);
		free(data);
		data = scaled_data;
	}

next:
    if (texborder)
    {
        data = AddBorderToImage(data, scaled_width, scaled_height, 1);
        scaled_width += 2;
        scaled_height += 2;
        border = 1;
    }
    data = FillBlankPixelsWithAdjacentColors(data, scaled_width, scaled_height);

	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_2D, texture);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, mintype);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magtype);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    //glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_BORDER_COLOR, bordercolor);
	//glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
    //if (mintype == GL_LINEAR || mintype == GL_NEAREST)
	    glTexImage2D(GL_TEXTURE_2D, 0, 4, scaled_width, scaled_height, border, GL_RGBA, GL_UNSIGNED_BYTE, data);/*
    else
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, scaled_width, scaled_height, GL_RGBA, GL_UNSIGNED_BYTE, data);*/

	free(data);

	return texture;
}

//
// V_Init
// 
void V_Init (void) 
{
	int		nummpnames;
	int		size, i, j, lump;
	GLuint	texture;
    char	buffer[9];
    char	name[9];
    int     p;
    GLenum  filtertype;

    p = M_CheckParm("-minfilter");
    if (p && p < myargc-1)
        minfilter = atoi(myargv[p+1]);
    p = M_CheckParm("-magfilter");
    if (p && p < myargc-1)
        magfilter = atoi(myargv[p+1]);
    p = M_CheckParm("-patchfilter");
    if (p && p < myargc-1)
        patchfilter = atoi(myargv[p+1]);
    p = M_CheckParm("-spritefilter");
    if (p && p < myargc-1)
        spritefilter = atoi(myargv[p+1]);
    p = M_CheckParm("-texborder");
    if (p && p < myargc-1)
        texborder = atoi(myargv[p+1]);

    switch (minfilter)
    {
    case 0:
        minfiltertype = GL_NEAREST;
        break;
    case 1:
        minfiltertype = GL_LINEAR;
        break;
    case 2:
        minfiltertype = GL_NEAREST_MIPMAP_NEAREST;
        break;
    case 3:
        minfiltertype = GL_NEAREST_MIPMAP_LINEAR;
        break;
    case 4:
        minfiltertype = GL_LINEAR_MIPMAP_NEAREST;
        break;
    case 5:
        minfiltertype = GL_LINEAR_MIPMAP_LINEAR;
        break;
    }

    switch (magfilter)
    {
    case 0:
        magfiltertype = GL_NEAREST;
        break;
    case 1:
        magfiltertype = GL_LINEAR;
        break;
    }

    if (patchfilter)
        filtertype = GL_LINEAR;
    else
        filtertype = GL_NEAREST;
    
	playpal = W_CacheLumpName("PLAYPAL", PU_STATIC);

	size = numlumps * sizeof(*texture_objects);
    texture_objects = malloc (size);
	memset (texture_objects, 0xFF, size); // @texture object number0g邱Ƃ͖̂ŁA-1ł͂Ȃ0gׂ

	nummpnames = sizeof(mpnames)/sizeof(mpnames[0]);
	for (i=0 ; i<nummpnames ; i++)
	{
		lump = W_CheckNumForName(mpnames[i]);
		if (lump < 0)
			continue; // @IWADɂĖpatch
		texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_STATIC), filtertype, filtertype);
		if ((signed int)texture == -1)
			I_Error("V_Init: texture object number 0xFFF...F is used");
		texture_objects[lump] = texture;
	}

	j = HU_FONTSTART;
    for (i=0;i<HU_FONTSIZE;i++)
    {
		sprintf(buffer, "STCFN%.3d", j++);
		lump = W_CheckNumForName(buffer);
		texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_STATIC), filtertype, filtertype);
		if ((signed int)texture == -1)
			I_Error("V_Init: texture object number 0xFFF...F is used");
		texture_objects[lump] = texture;
	}

    // @intermissionŎgpatcḧꕔ
    if (gamemode == commercial)
    {
        for (i=0 ; i<32/*NUMCMAPS*/ ; i++)
	    {								
	        sprintf(name, "CWILV%2.2d", i);
            lump = W_CheckNumForName(name);
            if (lump < 0)
			    continue;
	        texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_STATIC), filtertype, filtertype);
            if ((signed int)texture == -1)
			    I_Error("V_Init: texture object number 0xFFF...F is used");
		    texture_objects[lump] = texture;
	    }					
    }
    else
    {
        int epsd;

        for (epsd=0 ; epsd<3 ; epsd++)
        {
	        for (i=0 ; i<9/*NUMMAPS*/ ; i++)
	        {
	            sprintf(name, "WILV%d%d", epsd, i);
                lump = W_CheckNumForName(name);
                if (lump < 0)
			        continue;
	            texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_STATIC), filtertype, filtertype);
                if ((signed int)texture == -1)
			        I_Error("V_Init: texture object number 0xFFF...F is used");
		        texture_objects[lump] = texture;
	        }

            for (j=0 ; j<10/*NUMANIMS[wbs->epsd]*/ ; j++)
                for (i=0 ; i<3/*a->nanims*/ ; i++)
                {
                    sprintf(name, "WIA%d%.2d%.2d", epsd, j, i);
                    lump = W_CheckNumForName(name);
                    if (lump < 0)
			            continue;
	                texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_STATIC), filtertype, filtertype);
                    if ((signed int)texture == -1)
			            I_Error("V_Init: texture object number 0xFFF...F is used");
		            texture_objects[lump] = texture;
                }
        }
    }
    for (i=0;i<10;i++)
    {
	    // numbers 0-9
	    sprintf(name, "WINUM%d", i);
        lump = W_CheckNumForName(name);
		texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_STATIC), filtertype, filtertype);
		if ((signed int)texture == -1)
			I_Error("V_Init: texture object number 0xFFF...F is used");
		texture_objects[lump] = texture;
    }
}

GLuint CreateTexureObjectFromFlat(byte* flat)
{
    int     i;
    byte    dest[4096][4];
    int     index;
    GLuint  texture;

    for (i=0 ; i<4096 ; i++)
    {
        index = flat[i];
        dest[i][0] = playpal[index*3];
        dest[i][1] = playpal[index*3+1];
        dest[i][2] = playpal[index*3+2];
        dest[i][3] = 255;
    }

    glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_2D, texture);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minfiltertype);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magfiltertype);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    if (minfiltertype == GL_LINEAR || minfiltertype == GL_NEAREST)
	    glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, dest);
    else
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 64, 64, GL_RGBA, GL_UNSIGNED_BYTE, dest);

    return texture;
}

void CacheFlatTextureObject(int lump)
{
    GLuint	texture;

    if ((int)(texture_objects[lump]) != -1)
        return;

    texture = CreateTexureObjectFromFlat( W_CacheLumpNum(lump, PU_CACHE) );
	if ((signed int)texture == -1)
		I_Error("CacheFlatTextureObject: texture object number 0xFFF...F is used");
	texture_objects[lump] = texture;
}

void ReleaseTextureObject(int lump)
{
    if ((int)(texture_objects[lump]) == -1)
        return;

    glDeleteTextures(1, &texture_objects[lump]);
    texture_objects[lump] = -1;
}

extern texture_t**      textures;
extern unsigned int*    gltextures;

void CacheWallTextureObject(int texnum)
{
    int			width, height, scaled_width, scaled_height;
	unsigned	*data, *scaled_data;
    GLuint      texobject;
    texture_t*  texture;
    texpatch_t* texpatch;
    patch_t*    patch;
    post_t*     column;
    int         i, x1, x2, x;

    if ((int)(gltextures[texnum]) != -1)
        return;

    texture = textures[texnum];

    width = texture->width;
    height = texture->height;
    data = calloc(width*height, 4);

    texpatch = texture->patches;
    for (i=0 ; i<texture->patchcount ; i++, texpatch++)
    {
        patch = W_CacheLumpNum(texpatch->patch, PU_CACHE);
        x1 = texpatch->originx;
        x2 = x1 + patch->width;

        if (x1 < 0)
            x = 0;
        else
            x = x1;

        if (x2 > width)
            x2 = width;

        for ( ; x<x2 ; x++)
        {
            column = (post_t *)((byte *)patch + patch->columnofs[x - x1]);
            DrawColumnInRGBA(column, (byte *)data, x, texpatch->originy, width, height);
        }
    }

    if (glvers >= 2)
    {
        scaled_width = width;
        scaled_height = height;
        goto next;
    }

    for (scaled_width=1 ; scaled_width<width ; scaled_width<<=1)
		;
	for (scaled_height=1 ; scaled_height<height ; scaled_height<<=1)
		;

	if (width != scaled_width || height != scaled_height)
	{
		scaled_data = calloc(scaled_width*scaled_height, 4);
		ResampleTexture(data, width, height, scaled_data, scaled_width, scaled_height);
		free(data);
		data = scaled_data;
	}

next:

	glGenTextures(1, &texobject);
	glBindTexture(GL_TEXTURE_2D, texobject);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minfiltertype);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magfiltertype);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	if (minfiltertype == GL_LINEAR || minfiltertype == GL_NEAREST)
	    glTexImage2D(GL_TEXTURE_2D, 0, 4, scaled_width, scaled_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, data);
    else
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, scaled_width, scaled_height, GL_RGBA, GL_UNSIGNED_BYTE, data);

	free(data);

    if ((signed int)texobject == -1)
		I_Error("CacheWallTextureObject: texture object number 0xFFF...F is used");

    gltextures[texnum] = texobject;
}

void ReleaseWallTextureObject(int texnum)
{
    if ((int)(gltextures[texnum]) == -1)
        return;

    glDeleteTextures(1, &gltextures[texnum]);
    gltextures[texnum] = -1;
}

void CacheSpriteTextureObject(int lump)
{
    GLuint	texture;
    GLenum  filtertype;

    if ((int)(texture_objects[lump]) != -1)
    {
        I_Debug("CacheSpriteTextureObject: already cached\n");
        return;
    }

    if (spritefilter)
        filtertype = GL_LINEAR;
    else
        filtertype = GL_NEAREST;

    texture = CreateTexureObjectFromPatch(W_CacheLumpNum(lump, PU_CACHE), filtertype, filtertype);
	if ((signed int)texture == -1)
		I_Error("CacheSpriteTextureObject: texture object number 0xFFF...F is used");
	texture_objects[lump] = texture;
}
